import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import peasy.*; 
import processing.serial.*; 
import controlP5.*; 
import processing.opengl.*; 
import Jama.Matrix; 

import Jama.*; 
import Jama.examples.*; 
import Jama.test.*; 
import Jama.util.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class UI_main_5_7 extends PApplet {

// Developer -> Demetris Pantelis - d.pantelis2@hotmail.com






PeasyCam camera;
ControlP5 cp5;
Serial myPort;


// "default" tab
Group input;
Slider2D plane;
ListBox list;
Textfield posX;
Textfield posY;
Textfield posZ;
Textfield rotX;
Textfield rotY;
Textfield rotZ;
Textfield P;
Textfield I;
Textfield D;
Textfield vel;
Textfield accel;
Textfield point;
Textfield p_move;
Textfield p_position;
Textfield move;
Textfield position;
Textarea PID_error_txt;
Button start;
Button stop;
Button reset_inc;
Button B_Pmove;
Button B_move;
Button B_Pgoto;
Button B_goto;
Slider PVelocity_Slider;
Slider PPosition_Slider;
Slider Velocity_Slider;
Slider Position_Slider;
Button block_input;
Button block_control;
Textarea COM_warning;
Button Add_Position;
Button Go_to_Position;
ListBox position_list;

// "Settings" tab
ColorPicker BG_cl;  // BackGround color
ColorPicker B_cl;  // Button color
ColorPicker J_cl;  // Joint color
ListBox COM_list;  // List with COM ports
Textlabel Connect_msg;
Textarea COM_status;
Textfield DH_a;
Textfield DH_alpha;
Textfield DH_d;
Textfield pos_limit;
Textfield neg_limit;
Textfield SL_path;
Textfield gear_ratio;
Button block_DH;
Button block_SL;
Toggle bit_type;
//Button Add;

int starting_id = 7;    // We assume that all SMS have IDs in sequence. Here is the ID of the first SMS.
int baud = 115200;    // Serail spped

int num_nodes = 0;    // Number of nodes that have been added
float[][] node_prop = new float[0][12];    // The properies of each node are stored here for future use.
float[][] node_DH = new float[0][4];  //  a:alpha:d:theta - Save the DH parameters that are given for each node
float[][] node_limit = new float[0][2];  // Limit of each joint
int[] bit_size = new int[0];  // Describes if each node uses a 15-bit or a 12-bit SMS
float[] node_ticks = new float[0];    // The ticks that are read from each node.
int[] gear_ration = new int[0];    // Determines the gear ration of each node
double[][] c_temp = new double[4][1];
int origin_size = 50;    // The size of the global XYZ origin
int Pid  = 300;    // Default P gain  --   probably unused
int pId = 50;    // Default I gain  --   probably unused
int piD = 30;    // Default D gain  --   probably unused
int source = 0;  // defines who is waiting for the serial data that was read. 0=readTicks 1=Initialization, 2=getPID
boolean start_update = false;
boolean stop_ser_event = false;
float[] end_effector = new float[2];  // The end efector coordinated. Two values are needed, one for a and one for d.
int sec = 77;  // some value biger then 59
float[] v_new = {0, 0, 0, 0};  // The new values of the 4 control fields
float[] v_old = new float[4];  // The old values of the 4 control fields
int slider_range = 10;
String s_path = "saves/";

ArrayList<Matrix> ML = new ArrayList<Matrix>();  // Matrix List;
double[][] garbage = {{1,0,0,0},{0,1,0,0},{0,0,1,0},{0,0,0,1}};
Matrix Rx = new Matrix(garbage);
Matrix Ry = new Matrix(garbage);
Matrix Rz = new Matrix(garbage);
Matrix Tran = new Matrix(garbage);
Matrix T = new Matrix(garbage);
Matrix temp = new Matrix(garbage);
Matrix Co = new Matrix(garbage);

public void setup()
{
  
  
  
  //DELETE
  //source = 1;
  //myPort = new Serial(this, Serial.list()[0], baud);
  //myPort.write('I');
  
  camera = new PeasyCam(this, 600);
  camera.setRotations(-1.0f, 0.0f, 0.0f);
  camera.lookAt(8.0f, -50.0f, 80.0f);
  camera.setActive(true);
  
  ML.add(T);

  cp5 = new ControlP5(this);
  load_UI(cp5);
  cp5.setAutoDraw(false);
  camera.setResetOnDoubleClick(false);
  
  // ****** Initialize *******
  

}


public void draw() 
{
  background(BG_cl.getColorValue());
  //lights();
  textSize(20);
//-----------------------------------------------------
  pushMatrix();
  translate(-75,75,0);
  stroke(255,0,0);
  line(0,0,0,75,0,0);
  fill(255,0,0);
  text("X", 80, 0, 0);
  
  stroke(0,255,0);
  line(0,0,0,0,75,0);
  fill(0,255,0);
  text("Y", 0, 80, 0);
  
  stroke(0,0,255);
  line(0,0,0,0,0,75);
  fill(0,0,255);
  text("Z", 0, 0, 80);
  
  popMatrix();
  //--------------------------------------------------
  for(int j=0;j<num_nodes;j++)
  //----------------------------------------------------
  stroke(250);
  fill(50);
  box(100, 100, 15);
  robot();
  noFill();
  noStroke();
  //--------------------------------------------------
  drawCylinder(300,1000,1000);
  //--------------------------------------------------
  camera.beginHUD();
  cp5.draw();
  camera.endHUD();
  
  //===================================================
  // Slider
  for(int j = 0;j<v_new.length;j++)
  {
    v_old[j] = v_new[j];
  }
  v_new[0] = PApplet.parseFloat(p_move.getText());
  //v_new[1] = float(p_position.getText());
  v_new[2] = PApplet.parseFloat(move.getText());
  //v_new[3] = float(position.getText());

  if(v_new[0]>0 || v_new[0]<=0)
  {
    PVelocity_Slider.setRange( v_new[0]-slider_range, v_new[0]+slider_range );
    if(v_new[0] != v_old[0])
    {
      PVelocity_Slider.setValue(v_new[0]);
    }
  }
  /*
  if(v_new[1]>0 || v_new[1]<=0)
  {
    PPosition_Slider.setRange( v_new[1]-slider_range, v_new[1]+slider_range );
    if(v_new[1] != v_old[1])
    {
      PPosition_Slider.setValue(v_new[1]);
    }
  }
  */
    if(v_new[2]>0 || v_new[2]<=0)
  {
    Velocity_Slider.setRange( v_new[2]-slider_range, v_new[2]+slider_range );
    if(v_new[2] != v_old[2])
    {
      Velocity_Slider.setValue(v_new[2]);
    }
  }
  /*
  if(v_new[3]>0 || v_new[3]<=0)
  {
    Position_Slider.setRange( v_new[3]-slider_range, v_new[3]+slider_range );
    if(v_new[3] != v_old[3])
    {
      Position_Slider.setValue(v_new[3]);
    }
  }
  */
}

//References
/*
~For cylinder -- http://vormplus.be/blog/article/drawing-a-cylinder-with-processing
~Matrix - http://math.nist.gov/javanumerics/jama/doc/
~ArrayList - http://docs.oracle.com/javase/1.5.0/docs/api/java/util/ArrayList.html#get(int)
*/
public void load_UI(ControlP5 cp5)
{

    cp5.addButton("Serial_clear")
      .setPosition(500,10)
      .setVisible(false)
      .setSize(60,60);
// ******************************************************************
// ************************** Tabs **********************************
// ******************************************************************
  cp5.getTab("default")
     .setLabel("Main")
     .setSize(100,100);
     
  cp5.addTab("Settings")
     .setColorBackground(color(0, 160, 100))
     .setColorLabel(color(255))
     .setColorActive(color(255,128,0))
     .setSize(100,100);
     
  cp5.addTab("Information")
     .setColorBackground(color(0, 160, 100))
     .setColorLabel(color(255))
     .setColorActive(color(255,128,0))
     .setSize(100,100);
  
// ******************************************************************
// ************************ In-put **********************************
// ******************************************************************
//------------------------- Top Buttons ----------------------------
  input = cp5.addGroup("Commands")
      .setPosition(20,50)
      .setBackgroundHeight(600)
      .setBackgroundColor(color(255,50))
      .setWidth(230)
      .setVisible(true)
      .moveTo("default");
      
  cp5.addButton("Do_math")
      .setPosition(120,10)
      .setSize(45,45)
      .setGroup(input);
      
  cp5.addButton("Halt")
      .setPosition(175,10)
      .setSize(45,100)
      .setGroup(input);
      
  start = cp5.addButton("Start")
      .setPosition(10,10)
      .setSize(100,100)
      .setGroup(input);
      
  stop = cp5.addButton("Stop")
      .setPosition(10,120)
      .setSize(100,40)
      .setGroup(input);
      
  reset_inc = cp5.addButton("Reset_Inc")
      .setPosition(120,65)
      .setSize(45,95)
      .setGroup(input);
      
  cp5.addButton("Reset_err")
      .setPosition(175,120)
      .setSize(45,40)
      .setGroup(input);
      
  block_input = cp5.addButton("Block_input")
      .setPosition(-15,-15)
      .setSize(260,630)
      .setLabelVisible(false)
      .setColorBackground(color(0,0,0,95))
      .setColorActive(color(0,0,0,95))
      .setColorForeground(color(0,0,0,95))
      .setGroup(input);
      
// --------------------- Properties ---------------------   
  list = cp5.addListBox("Nodes")
      .setPosition(20,170)
      .setSize(180,30)//170
      .setItemHeight(25)
      .setBarHeight(30)
      .setColorActive(color(0,150,200))
      .setColorForeground(color(255,100,0))
      .setGroup(input);
      
  Group properties = cp5.addGroup("Properties")
      .setPosition(25,370)
      .setBackgroundHeight(170)
      .setBackgroundColor(color(255,50))
      .setWidth(180)
      .setGroup(input);
      
  cp5.addButton("Apply_Changes")
      .setPosition(20, 10)
      .setSize(140,45)
      .setGroup(properties);
 /*     
  posX = cp5.addTextfield("pX")
      .setPosition(10,10)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
      
  posY = cp5.addTextfield("pY")
      .setPosition(65,10)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
      
  posZ = cp5.addTextfield("pZ")
      .setPosition(120,10)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
      
  rotX = cp5.addTextfield("rX")
      .setPosition(10,40)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
      
  rotY = cp5.addTextfield("rY")
      .setPosition(65,40)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
      
  rotZ = cp5.addTextfield("rZ")
      .setPosition(120,40)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
   */   
  P = cp5.addTextfield("P")
      .setPosition(10,70)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
      
  I = cp5.addTextfield("I")
      .setPosition(65,70)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
      
  D = cp5.addTextfield("D")
      .setPosition(120,70)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
      
  vel = cp5.addTextfield("Velocity")
      .setPosition(10,115)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
      
  accel = cp5.addTextfield("Acceleration")
      .setPosition(65,115)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
      
  point = cp5.addTextfield("Point")
      .setPosition(120,115)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
   
//------------------- Other(Input) --------------------
  COM_warning = cp5.addTextarea("COM_state")
      .setPosition(10,550)
      .setSize(210,40)
      .setFont(createFont("arial",18))
      .setLineHeight(14)
      .setColor(color(0))
      .setColorBackground(color(150))
      .setColorForeground(color(255,100))
      .setText("      No connection")
      .setGroup(input);
   
//*****************************************************
//*************** DH parameters ***********************
//*****************************************************
   
//---------------------- propeDH_para---------------
Group DH_para = cp5.addGroup("DH Parameters")
      .setPosition(60,60)
      .setBackgroundHeight(350)
      .setBackgroundColor(color(255,50))
      .setWidth(180)
      .moveTo("Settings");
      
  DH_a = cp5.addTextfield("DH a")
      .setPosition(10,10)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setText("0")
      .setGroup(DH_para);
      
  DH_alpha = cp5.addTextfield("DH alpha")
      .setPosition(65,10)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setText("0")
      .setGroup(DH_para);
      
  DH_d = cp5.addTextfield("DH d")
      .setPosition(120,10)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setText("0")
      .setGroup(DH_para);
      
  pos_limit = cp5.addTextfield("+ limit")
      .setPosition(120,55)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setText("45")
      .setGroup(DH_para);
      
  neg_limit = cp5.addTextfield("- limit")
      .setPosition(10,55)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setText("-45")
      .setGroup(DH_para);
/*      
  gear_ratio = cp5.addTextfield("Gear Ratio")
      .setPosition(60,100)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setText("-45")
      .setGroup(DH_para);
      
  cp5.addTextlabel("Ge_Ra")
      .setText(":1")
      .setPosition(110,100)
      .setColorValue(color(0))
      .setFont(createFont("Georgia",20))
      .setGroup(DH_para);
*/      
  bit_type = cp5.addToggle("Bit_type")
      .setPosition(65,160)
      .setSize(50,25)
      .setValue(true)
      .setMode(ControlP5.SWITCH)
      .setLabelVisible(false)
      .setGroup(DH_para);
      
  cp5.addTextlabel("15_bit")
      .setText("15-bit")
      .setPosition(10,160)
      .setColorValue(color(0))
      .setFont(createFont("Georgia",16))
      .setGroup(DH_para);
      
  cp5.addTextlabel("12_bit")
      .setText("12-bit")
      .setPosition(115,160)
      .setColorValue(color(0))
      .setFont(createFont("Georgia",16))
      .setGroup(DH_para);
       
  cp5.addButton("Add")
      .setPosition(10,195)
      .setSize(160,40)
      .setGroup(DH_para);
      
  cp5.addButton("Delete")
      .setPosition(10,245)
      .setSize(160,40)
      .setGroup(DH_para);
      
  cp5.addButton("End_effector")
      .setPosition(10,295)
      .setSize(160,40)
      .setGroup(DH_para);
      
  block_DH = cp5.addButton("Block_DH")
      .setPosition(-15,-15)
      .setSize(210,380)
      .setLabelVisible(false)
      .setColorBackground(color(0,0,0,95))
      .setColorActive(color(0,0,0,95))
      .setColorForeground(color(0,0,0,95))
      .setGroup(DH_para);

// ******************************************************************
// ************************ Control *********************************
// ******************************************************************
//---------------------- Profily Motion ----------------
  Group control = cp5.addGroup("Control")
      .setPosition(760,20)
      .setBackgroundHeight(360)
      .setBackgroundColor(color(255,50))
      .setWidth(230)
      .moveTo("default");

  p_move = cp5.addTextfield("P_Velocity")
      .setPosition(10,10)
      .setSize(100,25)
      .setFont(createFont("arial",18))
      .setText("0")
      .setGroup(control);
      
  B_Pmove = cp5.addButton("P_Move")
      .setPosition(130, 10)
      .setSize(90,30)
      .setLock(true)
      .setGroup(control); 
      
  PVelocity_Slider = cp5.addSlider("Profiled_Velocity_Slider")
     .setPosition(10,50)
     .setSize(140,20)
     .setRange(-slider_range,slider_range)
     .setValue(0)
     .setCaptionLabel("")
     .setGroup(control);
           
  p_position = cp5.addTextfield("P_Position")
      .setPosition(10,100)
      .setSize(100,25)
      .setFont(createFont("arial",18))
      .setText("0")
      .setGroup(control);
      
  B_Pgoto = cp5.addButton("P_Go_to")
      .setPosition(130, 100)
      .setSize(90,30)
      .setLock(true)
      .setGroup(control);  
      
  PPosition_Slider = cp5.addSlider("Profiled_Position_Slider")
     .setPosition(10,140)
     .setSize(160,20)
     .setRange(-slider_range,slider_range)
     .setValue(0)
     .setCaptionLabel("")
     .setGroup(control);
      
// --------------------- Motion --------------------- 
  move = cp5.addTextfield("Velocity.")
      .setPosition(10,190)
      .setSize(100,25)
      .setFont(createFont("arial",18))
      .setText("0")
      .setGroup(control);
      
  B_move = cp5.addButton("Move")
      .setPosition(130, 190)
      .setSize(90,30)
      .setLock(true)
      .setGroup(control);
      
  Velocity_Slider = cp5.addSlider("Velocity_Slider")
     .setPosition(10,230)
     .setSize(160,20)
     .setRange(-slider_range,slider_range)
     .setValue(0)
     .setCaptionLabel("")
     .setGroup(control);
      
  position = cp5.addTextfield("Position")
      .setPosition(10,280)
      .setSize(100,25)
      .setFont(createFont("arial",18))
      .setText("0")
      .setGroup(control);

  B_goto = cp5.addButton("Go_to")
      .setPosition(130, 280)
      .setSize(90,30)
      .setLock(true)
      .setGroup(control);  
      
  Position_Slider = cp5.addSlider("Position_Slider")
     .setPosition(10,320)
     .setSize(160,20)
     .setRange(-slider_range,slider_range)
     .setValue(0)
     .setCaptionLabel("")
     .setGroup(control);
     
  block_control = cp5.addButton("Block_control")
      .setPosition(-15,-15)
      .setSize(260,390)
      .setLabelVisible(false)
      .setColorBackground(color(0,0,0,95))
      .setColorActive(color(0,0,0,95))
      .setColorForeground(color(0,0,0,95))
      .setGroup(control);
      
// ******************************************************************
// ************************ --------- *******************************
// ******************************************************************
      
//------------------------- Warning msg -----------------------------
  Connect_msg = cp5.addTextlabel("label")
      .setText("Please select a COM from the 'Seting' tab")
      .setPosition(300,80)
      .setColorValue(0xfffff000)
      .setFont(createFont("Georgia",20))
      .moveTo("default");
      
// ******************************************************************
// ************************ PID Error *******************************
// ******************************************************************
  Group PID_error = cp5.addGroup("PID Error")
      .setPosition(width - 170, 20)
      .setBackgroundHeight(100)
      .setBackgroundColor(color(255,50))
      .setWidth(150)
      .setVisible(false)
      .moveTo("default");
      
  PID_error_txt = cp5.addTextarea("txt")
      .setPosition(10,10)
      .setSize(130,40)
      .setFont(createFont("arial",12))
      .setLineHeight(14)
      .setColor(color(128))
      .setColorBackground(color(74,0,101))
      .setColorForeground(color(255,100))
      .setGroup(PID_error);
      
  cp5.addButton("Reset_PID")
      .setPosition(10, 60)
      .setSize(130,30)
      .setGroup(PID_error); 
      
      
// ******************************************************************
// ************************ Real ticks and angles *******************
// ******************************************************************
/*
  plane = cp5.addSlider2D("wave")
       .setPosition(900,500)
       .setSize(100,100)
       .setArrayValue(new float[] {50, 50});
*/
// ******************************************************************
// ************************ Color Settings **************************
// ******************************************************************
  Group elem_color = cp5.addGroup("Colors")
      .setPosition(700,400)
      .setBackgroundHeight(180)
      .setBackgroundColor(color(255,50))
      .setWidth(280)
      .moveTo("Settings");
      
  BG_cl = cp5.addColorPicker("BackGround")
      .setPosition(10,10)
      .setColorValue(color(120,120,120))
      .activateEvent(false)
      .setGroup(elem_color);
      
  J_cl = cp5.addColorPicker("Joint Color")
      .setPosition(10,90)
      .setColorValue(color(255, 20, 20))
      .activateEvent(false)
      .setGroup(elem_color);

// ******************************************************************
// ************************ Port ************************************
// ******************************************************************
  Group COM = cp5.addGroup("COM")
      .setPosition(700,75)
      .setBackgroundHeight(240)
      .setBackgroundColor(color(255,50))
      .setWidth(280)
      .moveTo("Settings");

  COM_list = cp5.addListBox("COMs")
      .setPosition(20,20)
      .setSize(160,160)
      .setItemHeight(25)
      .setBarHeight(30)
      .setColorActive(color(0,150,200))
      .setColorForeground(color(255,100,0))
      .setGroup(COM);
      
  cp5.addButton("Detect")
      .setPosition(210,20)
      .setSize(50,50)
      .setGroup(COM);
      
  cp5.addButton("Connect")
      .setPosition(210,80)
      .setSize(50,50)
      .setGroup(COM);
      
  COM_status = cp5.addTextarea("COM_status")
      .setPosition(10,180)
      .setSize(260,40)
      .setFont(createFont("arial",20))
      .setLineHeight(14)
      .setColor(color(0))
      .setColorBackground(color(255,10,10))
      .setColorForeground(color(255,100))
      .setText("         No connection")
      .setGroup(COM);
      
// ******************************************************************
// ************************ Save/Load *******************************
// ******************************************************************
      
  Group configuration = cp5.addGroup("configuration")
      .setPosition(60,470)
      .setBackgroundHeight(160)
      .setBackgroundColor(color(255,50))
      .setWidth(190)
      //.setVisible(false)
      .moveTo("Settings");
      
  cp5.addButton("Save")
      .setPosition(10,10)
      .setSize(75,50)
      .setGroup(configuration);
      
  cp5.addButton("Load")
      .setPosition(105,10)
      .setSize(75,50)
      .setGroup(configuration);
      
  SL_path = cp5.addTextfield("Path")
      .setPosition(10,80)
      .setSize(170,25)
      .setFont(createFont("arial",18))
      .setText("def")
      .setGroup(configuration);
      
  block_SL = cp5.addButton("Block_SL")
      .setPosition(-15,-15)
      .setSize(220,190)
      .setLabelVisible(false)
      .setColorBackground(color(0,0,0,95))
      .setColorActive(color(0,0,0,95))
      .setColorForeground(color(0,0,0,95))
      .setGroup(configuration);
      
// ******************************************************************
// ************************ Other ***********************************
// ******************************************************************   
  cp5.addButton("Image")
     .setPosition(900,550)
     .setImages(loadImage("logo.jpg"), loadImage("logo.jpg"), loadImage("logo.jpg"))
     .updateSize()
     .moveTo("Information");
     
  cp5.addTextarea("Load code to arduino")
      .setPosition(10,50)
      .setSize(800,200)
      .setFont(createFont("Georgia",16))
      .setLineHeight(14)
      .setColor(color(0))
      //.setColorBackground(color(255,10,10))
      //.setColorForeground(color(255,100))
      .setText("No connection")
      .moveTo("Information")
      .setText("First, you need to add our 01SMS Arduino Library. "
             +" To do this simple open your Arduino IDE. Go to Sketch>Import Library>Add Library"
             +" Then browse to the folder where you unziped the 01Robot programme. There you will find a"
             +" zip file named ZerooneSupermodified103.zip. Click on it and press OK"
              );
  cp5.addTextarea("Load code to arduino2")
      .setPosition(10,120)
      .setSize(800,200)
      .setFont(createFont("Georgia",16))
      .setLineHeight(14)
      .setColor(color(0))
      //.setColorBackground(color(255,10,10))
      //.setColorForeground(color(255,100))
      .setText("No connection")
      .moveTo("Information")
      .setText("Now you need to burn our Arduino code on your device. Click File>Open and browse"
             +" to the unziped folder again. There you will find a folder with the name Arduino in it."
             +" That folder will contain a .ino file. Open it and click upload"
              ); 
              
  cp5.addTextarea("Load code to arduino3")
      .setPosition(10,180)
      .setSize(800,200)
      .setFont(createFont("Georgia",16))
      .setLineHeight(14)
      .setColor(color(0))
      //.setColorBackground(color(255,10,10))
      //.setColorForeground(color(255,100))
      .setText("No connection")
      .moveTo("Information")
      .setText("Now double click on the .exe file of the 01Robot programme and you are good to go!"); 
              
  cp5.addTextarea("Load code to arduino4")
      .setPosition(10,210)
      .setSize(800,200)
      .setFont(createFont("Georgia",16))
      .setLineHeight(14)
      .setColor(color(0))
      //.setColorBackground(color(255,10,10))
      //.setColorForeground(color(255,100))
      .setText("No connection")
      .moveTo("Information")
      .setText("Please consult the manual for extra information."); 
              
    
}
// ******************************************************************
// ************************ Events **********************************
// ******************************************************************    

public void Add()
{
  num_nodes++;
  start_update = true;
  list.addItem("node "+num_nodes, num_nodes);
  if(num_nodes<=5){ list.setSize( 180,30+(25*num_nodes) ); }  // Incrice the height of the list according to the amoung of element tha exint with in it.
  node_prop = (float[][])append(node_prop, new float[]{0,0,100,  0,0,0,  0,50,30,  1,1,1});  // Give default values that the new node will have : X/Y/Z-roll/pitch/yaw-PID-vell/accel/point
  node_DH = (float[][])append(node_DH, new float[]{PApplet.parseFloat(DH_a.getText()), PApplet.parseFloat(DH_alpha.getText()), PApplet.parseFloat(DH_d.getText()), 0});
  node_limit = (float[][])append(node_limit, new float[]{PApplet.parseFloat(pos_limit.getText()), PApplet.parseFloat(neg_limit.getText())});
  node_ticks = append(node_ticks, 0);
  gear_ration = append( gear_ration, PApplet.parseInt(gear_ratio.getText()) );
  if(bit_type.getValue() == 1.0f) {   bit_size = append(bit_size, 32768);  }
  else {  bit_size = append(bit_size, 4096);  }
  
  
  //-------------------------------------------------------------------------
  double[][] rx = { {1,0,0,0} , { 0, cos(radians(0)), -sin(radians(0)), 0 } , { 0, sin(radians(0)), cos(radians(0)), 0 } , {0,0,0,1} };
  double[][] ry = { { cos(radians(0)), 0, sin(radians(0)), 0} , {0,1,0,0} , { -sin(radians(0)), 0, cos(radians(0)), 0 } , {0,0,0,1} };
  double[][] rz = { { cos(radians(0)), -sin(radians(0)), 0, 0 }, { sin(radians(0)), cos(radians(0)), 0, 0 }, {0,0,1,0}, {0,0,0,1} };
  double[][] tran = { {1,0,0,0}, {0,1,0,0}, {0,0,1,0}, {0,0,0,1} };
  Rx = new Matrix(rx);
  Ry = new Matrix(ry);
  Rz = new Matrix(rz);
  Tran = new Matrix(tran);
  T = Tran.times( Rz.times( Ry.times(Rx) ) );

  temp = ML.get(ML.size()-1);
  T = temp.times(T); 
  ML.add(T);
  //----------------------------------------------------------------------------
  /*if(num_nodes==1)
  {
    rotX.setText(str( node_prop[0][3] ));
    rotY.setText(str( node_prop[0][4] ));
    rotZ.setText(str( node_prop[0][5] ));
  }*/
  //------------------------------------------------------------------------
  myPort.clear();
  source = 2;
 
  myPort.write('C');
  myPort.write(num_nodes+starting_id-1);
  delay(50);
  setLimits(num_nodes+starting_id-1, PApplet.parseFloat(pos_limit.getText()), PApplet.parseFloat(neg_limit.getText()) );
  delay(200);
  
}

//------------------------------------------------------------------
public void Delete()
{
  list.removeItem("node "+num_nodes);
  ML.remove(num_nodes);
  num_nodes--;
  if(num_nodes<=5){ list.setSize( 180,30+(25*num_nodes) ); }  // Incrice the height of the list according to the amoung of element tha exint with in it.
  
  float[][] temp_DH = new float[0][4];
  for(int i=0;i<node_DH.length-1;i++){ temp_DH = (float[][])append(temp_DH, new float[]{node_DH[i][0], node_DH[i][1], node_DH[i][2], node_DH[i][3]}); }
  node_DH = temp_DH;
  
  float[][] temp_limit = new float[0][2];
  for(int i=0;i<node_limit.length-1;i++){ temp_limit = (float[][])append(temp_limit, new float[]{node_limit[i][0], node_limit[i][1]}); }
  node_limit = temp_limit;

  int[] temp_bit = new int[0];
  for(int i=0;i<bit_size.length-1;i++){ temp_bit = append(temp_bit, bit_size[i]); }
  bit_size = temp_bit;

  myPort.write('D');
}

//-----------------------------------------------------------------
public void End_effector()
{
  end_effector[0] = PApplet.parseFloat(DH_a.getText());
  end_effector[1] = PApplet.parseFloat(DH_d.getText());
}

//---------------------------------------------------------------
public void Do_math()
{

}

//-----------------------------------------------------------------
public void Apply_Changes()
{
  int j = (int)list.getValue();
  /*node_prop[j][0] = float(posX.getText());
  node_prop[j][1] = float(posY.getText());
  node_prop[j][2] = float(posZ.getText());
  node_prop[j][3] = float(rotX.getText());
  node_prop[j][4] = float(rotY.getText());
  node_prop[j][5] = float(rotZ.getText());*/
  node_prop[j][6] = PApplet.parseFloat(P.getText());
  node_prop[j][7] = PApplet.parseFloat(I.getText());
  node_prop[j][8] = PApplet.parseFloat(D.getText());
  node_prop[j][9] = PApplet.parseFloat(vel.getText());
  node_prop[j][10] = PApplet.parseFloat(accel.getText());
  node_prop[j][11] = PApplet.parseFloat(point.getText());
  
  //-------------------------------------------------------------------------
  // Send new properties to motor
  int[] para = new int[6];
  para[0] = PApplet.parseInt(P.getText());
  para[1] = PApplet.parseInt(I.getText());
  para[2] = PApplet.parseInt(D.getText());
  para[3] = PApplet.parseInt(PApplet.parseFloat(vel.getText())*(bit_size[j]/360));
  para[4] = PApplet.parseInt(PApplet.parseFloat(accel.getText())*(bit_size[j]/360));
  para[5] = PApplet.parseInt(point.getText());
    
  para[3]++;
  para[4]++;
  para[5]++;
    // The reason a ++ has been added above to the para[] is because when
    // ever a 0 was sent, the serial would black out.
    // In the arduino code we dicrese these values by one again.
    // Update - does not work!!

  myPort.write('A');
  send_serial('P', j, para[0]);
  send_serial('I', j, para[1]);
  send_serial('D', j, para[2]);
  send_serial('V', j, para[3]);
  send_serial('C', j, para[4]);
  send_serial('O', j, para[5]);

}

//-----------------------------------------------------------------
public void Start()
{
  myPort.write('S');
  reset_inc.setLock(true);
  B_Pmove.setLock(false);
  B_Pgoto.setLock(false);
  B_move.setLock(false);
  B_goto.setLock(false);
  block_DH.setVisible(true);
  block_SL.setVisible(true);
}

//-------------------------------------------------------------
public void Stop()
{
  myPort.write('T');
  reset_inc.setLock(false);
  B_Pmove.setLock(true);
  B_Pgoto.setLock(true);
  B_move.setLock(true);
  B_goto.setLock(true);
  block_DH.setVisible(false);
  block_SL.setVisible(false);
}

//-----------------------------------------------------------------
public void Reset_err()
{
  myPort.write('R');
  myPort.write(num_nodes);
}

//-----------------------------------------------------------------
public void Reset_Inc()
{
  myPort.write('N');
  myPort.write(num_nodes);
}

//-----------------------------------------------------------------
public void P_Move()
{
  int j = (int)list.getValue();
  int val = PApplet.parseInt( PVelocity_Slider.getValue() * ((bit_size[j])/360));
  send_serial('V', j, val);
  println("Profiled Move: ",val);
}

//-----------------------------------------------------------------
public void P_Go_to()
{
  float val = PApplet.parseFloat(p_position.getText());
  PPosition_Slider.setRange( val-slider_range, val+slider_range );
  PPosition_Slider.setValue(val);
}

//+++++++++++++++++++
public void Profiled_Position_Slider(float value)
{
  if(num_nodes>0)
  {
    int j = (int)list.getValue();
    int val = PApplet.parseInt( value * ((bit_size[j])/360));
    send_serial('P', j, val);
    println("Profiled Slider Go To: ",val);
  }
}

//-----------------------------------------------------------------
public void Move()
{
  int j = (int)list.getValue();
  int val = PApplet.parseInt( Velocity_Slider.getValue() * ((bit_size[j])/360));
  send_serial('M', j, val);
  println("Move: ",val);
}

//-----------------------------------------------------------------
public void Go_to()
{
  float val = PApplet.parseFloat(position.getText());
  Position_Slider.setRange( val-slider_range, val+slider_range );
  Position_Slider.setValue(val);
}

//+++++++++++++++++++
public void Position_Slider(float value)
{
  if(num_nodes>0)
  {
    int j = (int)list.getValue();
    int val = PApplet.parseInt( value * ((bit_size[j])/360));
    send_serial('G', j, val);
    //println("Profiled Slider Go To: ",val);
  }
}

//------------------------------------------------------------------
public void Image()
{
  //setLimits(7,45.0,-45.0);
}

//-----------------------------------------------------------------
public void Halt()
{
  myPort.write('H');
  myPort.write(num_nodes);
}

//-----------------------------------------------------------------
public void Reset_PID()
{
  myPort.write('L');
  send_serial('L', (int)list.getValue(), Pid);
  send_serial('L', (int)list.getValue(), pId);
  send_serial('L', (int)list.getValue(), piD);
}

//-----------------------------------------------------------------
public void Detect()
{  
  for(int i=0;i<Serial.list().length;i++)
  {
    COM_list.addItem(Serial.list()[i], i);
  }
}

//-----------------------------------------------------------------
public void Connect()
{ 
  source = 1;
  myPort = new Serial(this, Serial.list()[(int)COM_list.getValue()], baud);
  myPort.write('I');
  myPort.write(starting_id);
  Connect_msg.setVisible(false);
  //input.setVisible(true);
  block_input.setVisible(false);
  block_control.setVisible(false);
  block_DH.setVisible(false);
  block_SL.setVisible(false);
}

//--------------------------------------------------------------
public void Save()
{
  XML tree =parseXML("<main></main>");

  String date = str(day()) + "/" + str(month()) + "/" + str(year());
  String NumOfNodes = str(num_nodes);
  tree.setString("date", date);
  tree.setString("Number_of_nodes", NumOfNodes);
  
  for(int j=0;j<num_nodes;j++)
  {
    String child = "node_" + str(j+1);
    XML nodeChild = tree.addChild(child);
    
    XML a = nodeChild.addChild("a");
    a.setContent( str(node_DH[j][0]) );
    XML aplha = nodeChild.addChild("alpha");
    aplha.setContent( str(node_DH[j][1]) );
    XML b = nodeChild.addChild("d");
    b.setContent( str(node_DH[j][2]) );
    XML P_limit = nodeChild.addChild("pos_limit");
    P_limit.setContent( str(node_limit[j][0]) );
    XML M_limit = nodeChild.addChild("neg_limit");
    M_limit.setContent( str(node_limit[j][1]) );
    XML bit_type = nodeChild.addChild("bit_type");
    bit_type.setContent( str(bit_size[j]) );

    String save_path = s_path + SL_path.getText() + ".xml";
    saveXML(tree, save_path);
  }
}

//-----------------------------------------------------------------
public void Load()
{
  XML tree;
  String path = s_path + SL_path.getText() + ".xml";
  tree = loadXML(path);
  int temp_num_nodes = PApplet.parseInt(tree.getString("Number_of_nodes"));
  for(int j=0;j<temp_num_nodes;j++)
  {
    String child = "node_" + str(j+1);
    XML nodeChild = tree.getChild(child);
    
    XML a = nodeChild.getChild("a");
    XML alpha = nodeChild.getChild("alpha");
    XML d = nodeChild.getChild("d");
    XML pos_limit = nodeChild.getChild("pos_limit");
    XML neg_limit = nodeChild.getChild("neg_limit");
    XML bit_type = nodeChild.getChild("bit_type");
    
    node_DH = (float[][])append(node_DH, new float[]{PApplet.parseFloat(a.getContent()), PApplet.parseFloat(alpha.getContent()), PApplet.parseFloat(d.getContent()), 0});
    node_limit = (float[][])append(node_limit, new float[]{PApplet.parseFloat(pos_limit.getContent()), PApplet.parseFloat(neg_limit.getContent())});    
    node_prop = (float[][])append(node_prop, new float[]{0,0,100,  0,0,0,  0,50,30,  1,1,1});  // Give default values that the new node will have : X/Y/Z-roll/pitch/yaw-PID-vell/accel/point
    node_ticks = append(node_ticks, 0);
    bit_size = append( bit_size, PApplet.parseInt(bit_type.getContent()) );

    list.addItem(child, j+1);
    num_nodes++;
    if(num_nodes<=5){ list.setSize( 180,30+(25*num_nodes) ); }  // Incrice the height of the list according to the amoung of element tha exint with in it.

    //source = 4;
    //setLimits(j+starting_id, node_limit[j][0], node_limit[j][1] );
    delay(30);
  }
  //*******************
  start_update = true;
  myPort.clear();
  source = 3;
  /*
  for(int i=0;i<temp_num_nodes;i++)
  {
    println("turn",i);
    num_nodes++;
    source = 2;
    myPort.write('C');
    myPort.write(num_nodes+starting_id-1);
    delay(250);
  }*/
  //println("Num_nodes",num_nodes);
  myPort.write('U');
  myPort.write(num_nodes);
  delay(100);
  
  for(int j=0;j<num_nodes;j++)
  {
    delay(50);
    setLimits(j+starting_id, node_limit[j][0], node_limit[j][1] );
  }

}

//-----------------------------------------------------------------
public void controlEvent(ControlEvent theEvent) 
{  
  if(theEvent.isFrom(list) && (int)list.getValue()<num_nodes)
  {
    println("list is",(int)list.getValue());
    int j = (int)list.getValue();
    /*posX.setText(str( node_prop[(int)list.getValue()][0] ));
    posY.setText(str( node_prop[(int)list.getValue()][1] ));
    posZ.setText(str( node_prop[(int)list.getValue()][2] ));
    rotX.setText(str( node_prop[(int)list.getValue()][3] ));
    rotY.setText(str( node_prop[(int)list.getValue()][4] ));
    rotZ.setText(str( node_prop[(int)list.getValue()][5] ));*/
    
    P.setText(str( node_prop[j][6] ));
    I.setText(str( node_prop[j][7] ));
    D.setText(str( node_prop[j][8] ));
    vel.setText(str( node_prop[j][9] ));
    accel.setText(str( node_prop[j][10] ));
    point.setText(str( node_prop[j][11] ));
  }
  
}

//----------------------------------------------------------------------
public void keyPressed() {
  
 if (key == ' ') 
 {
   camera.setRotations(-1.0f, 0.0f, 0.0f);
   camera.lookAt(8.0f, -50.0f, 80.0f);
   camera.setDistance(666);
 }
 else if(key =='z')
 {
   camera.setRotations(0.0f, 0.0f, 0.0f);
   camera.lookAt(8.0f, -50.0f, 80.0f);
   camera.setDistance(666);
 }
 else if(key =='y')
 {
   camera.setRotations(-1.68f, -0.08f, 0.0f);
   camera.lookAt(8.0f, -50.0f, 80.0f);
   camera.setDistance(666);
 }
 else if(key =='x')
 {
   camera.setRotations(-1.57f, 1.57f, 0.0f);
   camera.lookAt(8.0f, -50.0f, 80.0f);
   camera.setDistance(666);
 }/*
 else if(key == 't')
 {  
    getTicks();
 }*/
}

//---------------------------------------------------------------------
public void serialEvent(Serial myPort)  // Read PID values
{
  if(stop_ser_event==false)
  {
    String  inString = myPort.readStringUntil('\n');
    
    if (inString != null) // if we get any bytes other than the linefeed:
    {
      println(inString);
      String inString2 = trim(inString);  // remove the linefeed
      int inputArray[] = PApplet.parseInt(split(inString2, '\t'));  // split the string at the tabs and convert the sections into integers:
      inString = inString + 'O';  // Is needed so the propore message is displayed in the main tab
      
      
      if(inString.charAt(2)=='m' || inString.charAt(2)=='O')
      {
        COM_warning.setText("Connection: Warning");
        COM_warning.setFont(createFont("arial",18));
        COM_warning.setColorBackground(color(250,10,10));
      }
      else if( inString.charAt(0)=='-' || (int)inString.charAt(0)>=0 )  //If number between -32768 and +32768
      {
        COM_warning.setText("     Connection: OK");
        COM_warning.setFont(createFont("arial",16));
        COM_warning.setColorBackground(color(10,250,10));
      }
      
      if(source == 0)  // data is from getPosition
      {
        for(int i=0;i<inputArray.length;i++)
        {
          node_ticks[i] = inputArray[i];
          node_DH[i][3] = (inputArray[i]*360)/bit_size[i];
          //println("Ticks are",inputArray[i]);
        }
      }
      else if(source==1 && inputArray[0]==88)  //Initialize connection
      {
        COM_status.setText("    Connection was successful");
        COM_status.setFont(createFont("arial",16));
        COM_status.setColorBackground(color(10,250,10));
      }
      else if(source==2)  // data is form getPID
      {
        if (inputArray[0] <= 1 || inputArray[1] <= 1 || inputArray[2] <= 1)
        {
          PID_error_txt.setText("Error with property loading");
          PID_error_txt.setColorBackground(color(255,80,80));
          PID_error_txt.setColor(color(255));
        }
        else
        {
          node_prop[num_nodes-1][6] = inputArray[0];  //P
          node_prop[num_nodes-1][7] = inputArray[1];  //I
          node_prop[num_nodes-1][8] = inputArray[2];  //D 
          node_prop[num_nodes-1][9] = (inputArray[3]*360)/bit_size[num_nodes-1];  //Profiled Velocity
          node_prop[num_nodes-1][10] = (inputArray[4]*360)/bit_size[num_nodes-1];  //Profiled Acceleration
          PID_error_txt.setText("No error with property loading :-)");
          PID_error_txt.setColorBackground(color(80,255,80));
          PID_error_txt.setColor(color(0));
        }
      }
      else if(source==3)  // Load robot
      {
        int temp_five=0;
        for(int k=0;k<num_nodes;k++)
        {
          node_prop[k][6] = inputArray[0+temp_five];  //P
          node_prop[k][7] = inputArray[1+temp_five];  //I
          node_prop[k][8] = inputArray[2+temp_five];  //D
          node_prop[k][9] = (inputArray[3+temp_five]*360)/bit_size[k];  //Profiled Velocity
          node_prop[k][10] = (inputArray[4+temp_five]*360)/bit_size[k];  //Profiled Acceleration
          temp_five = temp_five +5;
        }
      }
      source = 0;
    }
  }

}

//-------------------------------------------------------
public void Serial_clear()
{
  myPort.clear();
}


  
// ******************************************************************
// ************************ Functions *******************************
// ******************************************************************  
public int prosthese(int a, int b)
{
  return(a+b);  
}

//-------------------------------------------------------
public void print_array(float[][] pin)
{
  println("in function");
  //prinln()
  for(int i=0;i<num_nodes;i++)
  {
    for(int j=0;j<3;j++)
    {
      print(pin[i][j]);
    }
    println();
  }
}

//-----------------------------------------------------------
public void robot()
{
  for(int i=0;i<num_nodes;i++)
  {
    //check if robot joint is in limit
    //println(i,node_DH[i][3]);
    //------------- Limiti control -------------
    /*
    if( node_DH[i][3] >= node_limit[i][0] )
    {
      myPort.write('O');
      myPort.write('U');
      myPort.write(i);
    }
    else if( node_DH[i][3] <= node_limit[i][1] )
    {
      myPort.write('O');
      myPort.write('D');
      myPort.write(i);
    }
    */
    //----------------coordinates---------------------
    pushMatrix();
    int k = 0;
    do
    {
      stroke(250);
      strokeWeight(8);
      line(0, 0, 0, node_DH[k][0], 0, node_DH[k][2]);
      
      translate( node_DH[k][0], 0, 0 );
      translate( 0, 0, node_DH[k][2] );
      rotateX( radians(node_DH[k][1]) );
      rotateZ( radians(node_DH[k][3]) );
      k = k+1;
    }while(k<=i);
    
    if(i == num_nodes-1)  // Display end-effector
    {
      stroke(0,190,0);
      strokeWeight(10);
      line(0, 0, 0, end_effector[0], 0, end_effector[1]);
      stroke(250);
    }
    strokeWeight(1);
    fill(J_cl.getColorValue());
    noStroke();
    drawCylinder( 30, 15, 30 );
    stroke(255,0,0);
    line(0,0,0,origin_size,0,0);
    stroke(0,255,0);
    line(0,0,0,0,origin_size,0);
    stroke(0,0,255);
    line(0,0,0,0,0,origin_size);
    
    // Graphic lines tha show the limits
    rotateZ( -radians(node_DH[i][3]) );
    rotateZ( radians(node_limit[i][0]) );
    stroke(0);
    line(0,0,0, origin_size+20,0,0);
    rotateZ( -radians(node_limit[i][0]) );
    rotateZ( radians(node_limit[i][1]) );
    line(0,0,0, origin_size+20,0,0);
    
    popMatrix();
    noFill();
    noStroke();
  }
}

//----------------------------------------------------------
public void getRobotPosition()
{
  source = 1;
}

//----------------------------------------------------------
/*void getTicks()
{
   source = 0;
   send_serial('Z',0,num_nodes);
}*/

//----------------------Send limits to Arduino----------------------
public void setLimits(int id, float pos_limit, float neg_limit)
{
  myPort.write('W');
  myPort.write(id);
  //println("ID is",id);
  int pLimit = (int)(pos_limit*32768)/360;  //need to add bit_size[i]
  send_int(pLimit);
  
  int nLimit = (int)(neg_limit*32768)/360;
  send_int(nLimit);
  println("pos limit",pLimit,"neg limit",nLimit);
  println();
}

//---------------------Cylinder-----------------------------
public void drawCylinder(int sides, float r, float h)
{
    float angle = 360 / sides;
    float halfHeight = h / 2;
    // draw top shape
    stroke(0);
    beginShape();
    for (int i = 0; i < sides; i++) {
        float x = cos( radians( i * angle ) ) * r;
        float y = sin( radians( i * angle ) ) * r;
        vertex( x, y, -halfHeight );    
    }
    endShape(CLOSE);
    
    // draw bottom shape
    beginShape();
    for (int i = 0; i < sides; i++) {
        float x = cos( radians( i * angle ) ) * r;
        float y = sin( radians( i * angle ) ) * r;
        vertex( x, y, halfHeight );    
    }
    endShape(CLOSE);
    
    // draw body
    noStroke();
    beginShape(TRIANGLE_STRIP);
    for (int i = 0; i < sides + 1; i++) {
        float x = cos( radians( i * angle ) ) * r;
        float y = sin( radians( i * angle ) ) * r;
        vertex( x, y, halfHeight);
        vertex( x, y, -halfHeight);    
    }
    endShape(CLOSE); 
} 


//--------------------------------------------------------
public void send_serial(char a, int id, int val)
{
  stop_ser_event = true;  // Stop Serial event handler from beeing called
  myPort.clear();    // Clear port of any data
  byte MSB,LSB,sing;
  sing = (byte) ((val & 0x7F000000) >> 24);

  if(sing==127)
  {
    MSB = (byte) ~((val & 0x0000FF00) >> 8);  //SB
    LSB = (byte) ~(val & 0x000000FF);  //LSB
    LSB++;
  }
  else
  {
    MSB = (byte) ((val & 0x0000FF00) >> 8);  //SB
    LSB = (byte) (val & 0x000000FF);  //LSB
  }
  id = starting_id + id;
  myPort.write((char)a);
  myPort.write(id);
  myPort.write(sing);
  myPort.write(MSB);
  myPort.write(LSB);
  delay(100);
  stop_ser_event = false;  // Allow serial event handler to be called again
}

//-------------------------------------------------------------------
public void send_int(int val)
{
  stop_ser_event = true;  // Stop Serial event handler from beeing called
  //myPort.clear();    // Clear port of any data
  byte MSB,LSB,sing;
  sing = (byte) ((val & 0x7F000000) >> 24);

  if(sing==127)
  {
    MSB = (byte) ~((val & 0x0000FF00) >> 8);  //SB
    LSB = (byte) ~(val & 0x000000FF);  //LSB
    LSB++;
    sing = 1;
  }
  else
  {
    MSB = (byte) ((val & 0x0000FF00) >> 8);  //SB
    LSB = (byte) (val & 0x000000FF);  //LSB
    sing = 0;
  }
  myPort.write(sing);
  myPort.write(MSB);
  myPort.write(LSB);
  delay(100);
  stop_ser_event = false;  // Allow serial event handler to be called again
}
  public void settings() {  size(1024, 680,P3D);  smooth(); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "UI_main_5_7" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
