// Developer -> Demetris Pantelis - d.pantelis2@hotmail.com
import peasy.*;
import processing.serial.*;
import controlP5.*;
import processing.opengl.*;
import Jama.Matrix;

PeasyCam camera;
ControlP5 cp5;
Serial myPort;


// "default" tab
Group input;
Slider2D plane;
ListBox list;
Textfield posX;
Textfield posY;
Textfield posZ;
Textfield rotX;
Textfield rotY;
Textfield rotZ;
Textfield P;
Textfield I;
Textfield D;
Textfield vel;
Textfield accel;
Textfield point;
Textfield p_move;
Textfield p_position;
Textfield move;
Textfield position;
Textarea PID_error_txt;
Button start;
Button stop;
Button reset_inc;
Button B_Pmove;
Button B_move;
Button B_Pgoto;
Button B_goto;
Slider PVelocity_Slider;
Slider PPosition_Slider;
Slider Velocity_Slider;
Slider Position_Slider;
Button block_input;
Button block_control;
Textarea COM_warning;
Button Add_Position;
Button Go_to_Position;
ListBox position_list;

// "Settings" tab
ColorPicker BG_cl;  // BackGround color
ColorPicker B_cl;  // Button color
ColorPicker J_cl;  // Joint color
ListBox COM_list;  // List with COM ports
Textlabel Connect_msg;
Textarea COM_status;
Textfield DH_a;
Textfield DH_alpha;
Textfield DH_d;
Textfield pos_limit;
Textfield neg_limit;
Textfield SL_path;
Textfield gear_ratio;
Button block_DH;
Button block_SL;
Toggle bit_type;
//Button Add;

int starting_id = 7;    // We assume that all SMS have IDs in sequence. Here is the ID of the first SMS.
int baud = 115200;    // Serail spped

int num_nodes = 0;    // Number of nodes that have been added
float[][] node_prop = new float[0][12];    // The properies of each node are stored here for future use.
float[][] node_DH = new float[0][4];  //  a:alpha:d:theta - Save the DH parameters that are given for each node
float[][] node_limit = new float[0][2];  // Limit of each joint
int[] bit_size = new int[0];  // Describes if each node uses a 15-bit or a 12-bit SMS
float[] node_ticks = new float[0];    // The ticks that are read from each node.
int[] gear_ration = new int[0];    // Determines the gear ration of each node
double[][] c_temp = new double[4][1];
int origin_size = 50;    // The size of the global XYZ origin
int Pid  = 300;    // Default P gain  --   probably unused
int pId = 50;    // Default I gain  --   probably unused
int piD = 30;    // Default D gain  --   probably unused
int source = 0;  // defines who is waiting for the serial data that was read. 0=readTicks 1=Initialization, 2=getPID
boolean start_update = false;
boolean stop_ser_event = false;
float[] end_effector = new float[2];  // The end efector coordinated. Two values are needed, one for a and one for d.
int sec = 77;  // some value biger then 59
float[] v_new = {0, 0, 0, 0};  // The new values of the 4 control fields
float[] v_old = new float[4];  // The old values of the 4 control fields
int slider_range = 10;
String s_path = "saves/";

ArrayList<Matrix> ML = new ArrayList<Matrix>();  // Matrix List;
double[][] garbage = {{1,0,0,0},{0,1,0,0},{0,0,1,0},{0,0,0,1}};
Matrix Rx = new Matrix(garbage);
Matrix Ry = new Matrix(garbage);
Matrix Rz = new Matrix(garbage);
Matrix Tran = new Matrix(garbage);
Matrix T = new Matrix(garbage);
Matrix temp = new Matrix(garbage);
Matrix Co = new Matrix(garbage);

void setup()
{
  size(1024, 680,P3D);
  smooth();
  
  //DELETE
  //source = 1;
  //myPort = new Serial(this, Serial.list()[0], baud);
  //myPort.write('I');
  
  camera = new PeasyCam(this, 600);
  camera.setRotations(-1.0, 0.0, 0.0);
  camera.lookAt(8.0, -50.0, 80.0);
  camera.setActive(true);
  
  ML.add(T);

  cp5 = new ControlP5(this);
  load_UI(cp5);
  cp5.setAutoDraw(false);
  camera.setResetOnDoubleClick(false);
  
  // ****** Initialize *******
  

}


void draw() 
{
  background(BG_cl.getColorValue());
  //lights();
  textSize(20);
//-----------------------------------------------------
  pushMatrix();
  translate(-75,75,0);
  stroke(255,0,0);
  line(0,0,0,75,0,0);
  fill(255,0,0);
  text("X", 80, 0, 0);
  
  stroke(0,255,0);
  line(0,0,0,0,75,0);
  fill(0,255,0);
  text("Y", 0, 80, 0);
  
  stroke(0,0,255);
  line(0,0,0,0,0,75);
  fill(0,0,255);
  text("Z", 0, 0, 80);
  
  popMatrix();
  //--------------------------------------------------
  for(int j=0;j<num_nodes;j++)
  //----------------------------------------------------
  stroke(250);
  fill(50);
  box(100, 100, 15);
  robot();
  noFill();
  noStroke();
  //--------------------------------------------------
  drawCylinder(300,1000,1000);
  //--------------------------------------------------
  camera.beginHUD();
  cp5.draw();
  camera.endHUD();
  
  //===================================================
  // Slider
  for(int j = 0;j<v_new.length;j++)
  {
    v_old[j] = v_new[j];
  }
  v_new[0] = float(p_move.getText());
  //v_new[1] = float(p_position.getText());
  v_new[2] = float(move.getText());
  //v_new[3] = float(position.getText());

  if(v_new[0]>0 || v_new[0]<=0)
  {
    PVelocity_Slider.setRange( v_new[0]-slider_range, v_new[0]+slider_range );
    if(v_new[0] != v_old[0])
    {
      PVelocity_Slider.setValue(v_new[0]);
    }
  }
  /*
  if(v_new[1]>0 || v_new[1]<=0)
  {
    PPosition_Slider.setRange( v_new[1]-slider_range, v_new[1]+slider_range );
    if(v_new[1] != v_old[1])
    {
      PPosition_Slider.setValue(v_new[1]);
    }
  }
  */
    if(v_new[2]>0 || v_new[2]<=0)
  {
    Velocity_Slider.setRange( v_new[2]-slider_range, v_new[2]+slider_range );
    if(v_new[2] != v_old[2])
    {
      Velocity_Slider.setValue(v_new[2]);
    }
  }
  /*
  if(v_new[3]>0 || v_new[3]<=0)
  {
    Position_Slider.setRange( v_new[3]-slider_range, v_new[3]+slider_range );
    if(v_new[3] != v_old[3])
    {
      Position_Slider.setValue(v_new[3]);
    }
  }
  */
}

//References
/*
~For cylinder -- http://vormplus.be/blog/article/drawing-a-cylinder-with-processing
~Matrix - http://math.nist.gov/javanumerics/jama/doc/
~ArrayList - http://docs.oracle.com/javase/1.5.0/docs/api/java/util/ArrayList.html#get(int)
*/