// ******************************************************************
// ************************ Events **********************************
// ******************************************************************    

public void Add()
{
  num_nodes++;
  start_update = true;
  list.addItem("node "+num_nodes, num_nodes);
  if(num_nodes<=5){ list.setSize( 180,30+(25*num_nodes) ); }  // Incrice the height of the list according to the amoung of element tha exint with in it.
  node_prop = (float[][])append(node_prop, new float[]{0,0,100,  0,0,0,  0,50,30,  1,1,1});  // Give default values that the new node will have : X/Y/Z-roll/pitch/yaw-PID-vell/accel/point
  node_DH = (float[][])append(node_DH, new float[]{float(DH_a.getText()), float(DH_alpha.getText()), float(DH_d.getText()), 0});
  node_limit = (float[][])append(node_limit, new float[]{float(pos_limit.getText()), float(neg_limit.getText())});
  node_ticks = append(node_ticks, 0);
  gear_ration = append( gear_ration, int(gear_ratio.getText()) );
  if(bit_type.getValue() == 1.0) {   bit_size = append(bit_size, 32768);  }
  else {  bit_size = append(bit_size, 4096);  }
  
  
  //-------------------------------------------------------------------------
  double[][] rx = { {1,0,0,0} , { 0, cos(radians(0)), -sin(radians(0)), 0 } , { 0, sin(radians(0)), cos(radians(0)), 0 } , {0,0,0,1} };
  double[][] ry = { { cos(radians(0)), 0, sin(radians(0)), 0} , {0,1,0,0} , { -sin(radians(0)), 0, cos(radians(0)), 0 } , {0,0,0,1} };
  double[][] rz = { { cos(radians(0)), -sin(radians(0)), 0, 0 }, { sin(radians(0)), cos(radians(0)), 0, 0 }, {0,0,1,0}, {0,0,0,1} };
  double[][] tran = { {1,0,0,0}, {0,1,0,0}, {0,0,1,0}, {0,0,0,1} };
  Rx = new Matrix(rx);
  Ry = new Matrix(ry);
  Rz = new Matrix(rz);
  Tran = new Matrix(tran);
  T = Tran.times( Rz.times( Ry.times(Rx) ) );

  temp = ML.get(ML.size()-1);
  T = temp.times(T); 
  ML.add(T);
  //----------------------------------------------------------------------------
  /*if(num_nodes==1)
  {
    rotX.setText(str( node_prop[0][3] ));
    rotY.setText(str( node_prop[0][4] ));
    rotZ.setText(str( node_prop[0][5] ));
  }*/
  //------------------------------------------------------------------------
  myPort.clear();
  source = 2;
 
  myPort.write('C');
  myPort.write(num_nodes+starting_id-1);
  delay(50);
  setLimits(num_nodes+starting_id-1, float(pos_limit.getText()), float(neg_limit.getText()) );
  delay(200);
  
}

//------------------------------------------------------------------
public void Delete()
{
  list.removeItem("node "+num_nodes);
  ML.remove(num_nodes);
  num_nodes--;
  if(num_nodes<=5){ list.setSize( 180,30+(25*num_nodes) ); }  // Incrice the height of the list according to the amoung of element tha exint with in it.
  
  float[][] temp_DH = new float[0][4];
  for(int i=0;i<node_DH.length-1;i++){ temp_DH = (float[][])append(temp_DH, new float[]{node_DH[i][0], node_DH[i][1], node_DH[i][2], node_DH[i][3]}); }
  node_DH = temp_DH;
  
  float[][] temp_limit = new float[0][2];
  for(int i=0;i<node_limit.length-1;i++){ temp_limit = (float[][])append(temp_limit, new float[]{node_limit[i][0], node_limit[i][1]}); }
  node_limit = temp_limit;

  int[] temp_bit = new int[0];
  for(int i=0;i<bit_size.length-1;i++){ temp_bit = append(temp_bit, bit_size[i]); }
  bit_size = temp_bit;

  myPort.write('D');
}

//-----------------------------------------------------------------
public void End_effector()
{
  end_effector[0] = float(DH_a.getText());
  end_effector[1] = float(DH_d.getText());
}

//---------------------------------------------------------------
public void Do_math()
{

}

//-----------------------------------------------------------------
public void Apply_Changes()
{
  int j = (int)list.getValue();
  /*node_prop[j][0] = float(posX.getText());
  node_prop[j][1] = float(posY.getText());
  node_prop[j][2] = float(posZ.getText());
  node_prop[j][3] = float(rotX.getText());
  node_prop[j][4] = float(rotY.getText());
  node_prop[j][5] = float(rotZ.getText());*/
  node_prop[j][6] = float(P.getText());
  node_prop[j][7] = float(I.getText());
  node_prop[j][8] = float(D.getText());
  node_prop[j][9] = float(vel.getText());
  node_prop[j][10] = float(accel.getText());
  node_prop[j][11] = float(point.getText());
  
  //-------------------------------------------------------------------------
  // Send new properties to motor
  int[] para = new int[6];
  para[0] = int(P.getText());
  para[1] = int(I.getText());
  para[2] = int(D.getText());
  para[3] = int(float(vel.getText())*(bit_size[j]/360));
  para[4] = int(float(accel.getText())*(bit_size[j]/360));
  para[5] = int(point.getText());
    
  para[3]++;
  para[4]++;
  para[5]++;
    // The reason a ++ has been added above to the para[] is because when
    // ever a 0 was sent, the serial would black out.
    // In the arduino code we dicrese these values by one again.
    // Update - does not work!!

  myPort.write('A');
  send_serial('P', j, para[0]);
  send_serial('I', j, para[1]);
  send_serial('D', j, para[2]);
  send_serial('V', j, para[3]);
  send_serial('C', j, para[4]);
  send_serial('O', j, para[5]);

}

//-----------------------------------------------------------------
public void Start()
{
  myPort.write('S');
  reset_inc.setLock(true);
  B_Pmove.setLock(false);
  B_Pgoto.setLock(false);
  B_move.setLock(false);
  B_goto.setLock(false);
  block_DH.setVisible(true);
  block_SL.setVisible(true);
}

//-------------------------------------------------------------
public void Stop()
{
  myPort.write('T');
  reset_inc.setLock(false);
  B_Pmove.setLock(true);
  B_Pgoto.setLock(true);
  B_move.setLock(true);
  B_goto.setLock(true);
  block_DH.setVisible(false);
  block_SL.setVisible(false);
}

//-----------------------------------------------------------------
public void Reset_err()
{
  myPort.write('R');
  myPort.write(num_nodes);
}

//-----------------------------------------------------------------
public void Reset_Inc()
{
  myPort.write('N');
  myPort.write(num_nodes);
}

//-----------------------------------------------------------------
public void P_Move()
{
  int j = (int)list.getValue();
  int val = int( PVelocity_Slider.getValue() * ((bit_size[j])/360));
  send_serial('V', j, val);
  println("Profiled Move: ",val);
}

//-----------------------------------------------------------------
public void P_Go_to()
{
  float val = float(p_position.getText());
  PPosition_Slider.setRange( val-slider_range, val+slider_range );
  PPosition_Slider.setValue(val);
}

//+++++++++++++++++++
void Profiled_Position_Slider(float value)
{
  if(num_nodes>0)
  {
    int j = (int)list.getValue();
    int val = int( value * ((bit_size[j])/360));
    send_serial('P', j, val);
    println("Profiled Slider Go To: ",val);
  }
}

//-----------------------------------------------------------------
public void Move()
{
  int j = (int)list.getValue();
  int val = int( Velocity_Slider.getValue() * ((bit_size[j])/360));
  send_serial('M', j, val);
  println("Move: ",val);
}

//-----------------------------------------------------------------
public void Go_to()
{
  float val = float(position.getText());
  Position_Slider.setRange( val-slider_range, val+slider_range );
  Position_Slider.setValue(val);
}

//+++++++++++++++++++
void Position_Slider(float value)
{
  if(num_nodes>0)
  {
    int j = (int)list.getValue();
    int val = int( value * ((bit_size[j])/360));
    send_serial('G', j, val);
    //println("Profiled Slider Go To: ",val);
  }
}

//------------------------------------------------------------------
public void Image()
{
  //setLimits(7,45.0,-45.0);
}

//-----------------------------------------------------------------
public void Halt()
{
  myPort.write('H');
  myPort.write(num_nodes);
}

//-----------------------------------------------------------------
public void Reset_PID()
{
  myPort.write('L');
  send_serial('L', (int)list.getValue(), Pid);
  send_serial('L', (int)list.getValue(), pId);
  send_serial('L', (int)list.getValue(), piD);
}

//-----------------------------------------------------------------
public void Detect()
{  
  for(int i=0;i<Serial.list().length;i++)
  {
    COM_list.addItem(Serial.list()[i], i);
  }
}

//-----------------------------------------------------------------
public void Connect()
{ 
  source = 1;
  myPort = new Serial(this, Serial.list()[(int)COM_list.getValue()], baud);
  myPort.write('I');
  myPort.write(starting_id);
  Connect_msg.setVisible(false);
  //input.setVisible(true);
  block_input.setVisible(false);
  block_control.setVisible(false);
  block_DH.setVisible(false);
  block_SL.setVisible(false);
}

//--------------------------------------------------------------
public void Save()
{
  XML tree =parseXML("<main></main>");

  String date = str(day()) + "/" + str(month()) + "/" + str(year());
  String NumOfNodes = str(num_nodes);
  tree.setString("date", date);
  tree.setString("Number_of_nodes", NumOfNodes);
  
  for(int j=0;j<num_nodes;j++)
  {
    String child = "node_" + str(j+1);
    XML nodeChild = tree.addChild(child);
    
    XML a = nodeChild.addChild("a");
    a.setContent( str(node_DH[j][0]) );
    XML aplha = nodeChild.addChild("alpha");
    aplha.setContent( str(node_DH[j][1]) );
    XML b = nodeChild.addChild("d");
    b.setContent( str(node_DH[j][2]) );
    XML P_limit = nodeChild.addChild("pos_limit");
    P_limit.setContent( str(node_limit[j][0]) );
    XML M_limit = nodeChild.addChild("neg_limit");
    M_limit.setContent( str(node_limit[j][1]) );
    XML bit_type = nodeChild.addChild("bit_type");
    bit_type.setContent( str(bit_size[j]) );

    String save_path = s_path + SL_path.getText() + ".xml";
    saveXML(tree, save_path);
  }
}

//-----------------------------------------------------------------
public void Load()
{
  XML tree;
  String path = s_path + SL_path.getText() + ".xml";
  tree = loadXML(path);
  int temp_num_nodes = int(tree.getString("Number_of_nodes"));
  for(int j=0;j<temp_num_nodes;j++)
  {
    String child = "node_" + str(j+1);
    XML nodeChild = tree.getChild(child);
    
    XML a = nodeChild.getChild("a");
    XML alpha = nodeChild.getChild("alpha");
    XML d = nodeChild.getChild("d");
    XML pos_limit = nodeChild.getChild("pos_limit");
    XML neg_limit = nodeChild.getChild("neg_limit");
    XML bit_type = nodeChild.getChild("bit_type");
    
    node_DH = (float[][])append(node_DH, new float[]{float(a.getContent()), float(alpha.getContent()), float(d.getContent()), 0});
    node_limit = (float[][])append(node_limit, new float[]{float(pos_limit.getContent()), float(neg_limit.getContent())});    
    node_prop = (float[][])append(node_prop, new float[]{0,0,100,  0,0,0,  0,50,30,  1,1,1});  // Give default values that the new node will have : X/Y/Z-roll/pitch/yaw-PID-vell/accel/point
    node_ticks = append(node_ticks, 0);
    bit_size = append( bit_size, int(bit_type.getContent()) );

    list.addItem(child, j+1);
    num_nodes++;
    if(num_nodes<=5){ list.setSize( 180,30+(25*num_nodes) ); }  // Incrice the height of the list according to the amoung of element tha exint with in it.

    //source = 4;
    //setLimits(j+starting_id, node_limit[j][0], node_limit[j][1] );
    delay(30);
  }
  //*******************
  start_update = true;
  myPort.clear();
  source = 3;
  /*
  for(int i=0;i<temp_num_nodes;i++)
  {
    println("turn",i);
    num_nodes++;
    source = 2;
    myPort.write('C');
    myPort.write(num_nodes+starting_id-1);
    delay(250);
  }*/
  //println("Num_nodes",num_nodes);
  myPort.write('U');
  myPort.write(num_nodes);
  delay(100);
  
  for(int j=0;j<num_nodes;j++)
  {
    delay(50);
    setLimits(j+starting_id, node_limit[j][0], node_limit[j][1] );
  }

}

//-----------------------------------------------------------------
public void controlEvent(ControlEvent theEvent) 
{  
  if(theEvent.isFrom(list) && (int)list.getValue()<num_nodes)
  {
    println("list is",(int)list.getValue());
    int j = (int)list.getValue();
    /*posX.setText(str( node_prop[(int)list.getValue()][0] ));
    posY.setText(str( node_prop[(int)list.getValue()][1] ));
    posZ.setText(str( node_prop[(int)list.getValue()][2] ));
    rotX.setText(str( node_prop[(int)list.getValue()][3] ));
    rotY.setText(str( node_prop[(int)list.getValue()][4] ));
    rotZ.setText(str( node_prop[(int)list.getValue()][5] ));*/
    
    P.setText(str( node_prop[j][6] ));
    I.setText(str( node_prop[j][7] ));
    D.setText(str( node_prop[j][8] ));
    vel.setText(str( node_prop[j][9] ));
    accel.setText(str( node_prop[j][10] ));
    point.setText(str( node_prop[j][11] ));
  }
  
}

//----------------------------------------------------------------------
void keyPressed() {
  
 if (key == ' ') 
 {
   camera.setRotations(-1.0, 0.0, 0.0);
   camera.lookAt(8.0, -50.0, 80.0);
   camera.setDistance(666);
 }
 else if(key =='z')
 {
   camera.setRotations(0.0, 0.0, 0.0);
   camera.lookAt(8.0, -50.0, 80.0);
   camera.setDistance(666);
 }
 else if(key =='y')
 {
   camera.setRotations(-1.68, -0.08, 0.0);
   camera.lookAt(8.0, -50.0, 80.0);
   camera.setDistance(666);
 }
 else if(key =='x')
 {
   camera.setRotations(-1.57, 1.57, 0.0);
   camera.lookAt(8.0, -50.0, 80.0);
   camera.setDistance(666);
 }/*
 else if(key == 't')
 {  
    getTicks();
 }*/
}

//---------------------------------------------------------------------
void serialEvent(Serial myPort)  // Read PID values
{
  if(stop_ser_event==false)
  {
    String  inString = myPort.readStringUntil('\n');
    
    if (inString != null) // if we get any bytes other than the linefeed:
    {
      println(inString);
      String inString2 = trim(inString);  // remove the linefeed
      int inputArray[] = int(split(inString2, '\t'));  // split the string at the tabs and convert the sections into integers:
      inString = inString + 'O';  // Is needed so the propore message is displayed in the main tab
      
      
      if(inString.charAt(2)=='m' || inString.charAt(2)=='O')
      {
        COM_warning.setText("Connection: Warning");
        COM_warning.setFont(createFont("arial",18));
        COM_warning.setColorBackground(color(250,10,10));
      }
      else if( inString.charAt(0)=='-' || (int)inString.charAt(0)>=0 )  //If number between -32768 and +32768
      {
        COM_warning.setText("     Connection: OK");
        COM_warning.setFont(createFont("arial",16));
        COM_warning.setColorBackground(color(10,250,10));
      }
      
      if(source == 0)  // data is from getPosition
      {
        for(int i=0;i<inputArray.length;i++)
        {
          node_ticks[i] = inputArray[i];
          node_DH[i][3] = (inputArray[i]*360)/bit_size[i];
          //println("Ticks are",inputArray[i]);
        }
      }
      else if(source==1 && inputArray[0]==88)  //Initialize connection
      {
        COM_status.setText("    Connection was successful");
        COM_status.setFont(createFont("arial",16));
        COM_status.setColorBackground(color(10,250,10));
      }
      else if(source==2)  // data is form getPID
      {
        if (inputArray[0] <= 1 || inputArray[1] <= 1 || inputArray[2] <= 1)
        {
          PID_error_txt.setText("Error with property loading");
          PID_error_txt.setColorBackground(color(255,80,80));
          PID_error_txt.setColor(color(255));
        }
        else
        {
          node_prop[num_nodes-1][6] = inputArray[0];  //P
          node_prop[num_nodes-1][7] = inputArray[1];  //I
          node_prop[num_nodes-1][8] = inputArray[2];  //D 
          node_prop[num_nodes-1][9] = (inputArray[3]*360)/bit_size[num_nodes-1];  //Profiled Velocity
          node_prop[num_nodes-1][10] = (inputArray[4]*360)/bit_size[num_nodes-1];  //Profiled Acceleration
          PID_error_txt.setText("No error with property loading :-)");
          PID_error_txt.setColorBackground(color(80,255,80));
          PID_error_txt.setColor(color(0));
        }
      }
      else if(source==3)  // Load robot
      {
        int temp_five=0;
        for(int k=0;k<num_nodes;k++)
        {
          node_prop[k][6] = inputArray[0+temp_five];  //P
          node_prop[k][7] = inputArray[1+temp_five];  //I
          node_prop[k][8] = inputArray[2+temp_five];  //D
          node_prop[k][9] = (inputArray[3+temp_five]*360)/bit_size[k];  //Profiled Velocity
          node_prop[k][10] = (inputArray[4+temp_five]*360)/bit_size[k];  //Profiled Acceleration
          temp_five = temp_five +5;
        }
      }
      source = 0;
    }
  }

}

//-------------------------------------------------------
public void Serial_clear()
{
  myPort.clear();
}


  