// ******************************************************************
// ************************ Functions *******************************
// ******************************************************************  
int prosthese(int a, int b)
{
  return(a+b);  
}

//-------------------------------------------------------
void print_array(float[][] pin)
{
  println("in function");
  //prinln()
  for(int i=0;i<num_nodes;i++)
  {
    for(int j=0;j<3;j++)
    {
      print(pin[i][j]);
    }
    println();
  }
}

//-----------------------------------------------------------
void robot()
{
  for(int i=0;i<num_nodes;i++)
  {
    //check if robot joint is in limit
    //println(i,node_DH[i][3]);
    //------------- Limiti control -------------
    /*
    if( node_DH[i][3] >= node_limit[i][0] )
    {
      myPort.write('O');
      myPort.write('U');
      myPort.write(i);
    }
    else if( node_DH[i][3] <= node_limit[i][1] )
    {
      myPort.write('O');
      myPort.write('D');
      myPort.write(i);
    }
    */
    //----------------coordinates---------------------
    pushMatrix();
    int k = 0;
    do
    {
      stroke(250);
      strokeWeight(8);
      line(0, 0, 0, node_DH[k][0], 0, node_DH[k][2]);
      
      translate( node_DH[k][0], 0, 0 );
      translate( 0, 0, node_DH[k][2] );
      rotateX( radians(node_DH[k][1]) );
      rotateZ( radians(node_DH[k][3]) );
      k = k+1;
    }while(k<=i);
    
    if(i == num_nodes-1)  // Display end-effector
    {
      stroke(0,190,0);
      strokeWeight(10);
      line(0, 0, 0, end_effector[0], 0, end_effector[1]);
      stroke(250);
    }
    strokeWeight(1);
    fill(J_cl.getColorValue());
    noStroke();
    drawCylinder( 30, 15, 30 );
    stroke(255,0,0);
    line(0,0,0,origin_size,0,0);
    stroke(0,255,0);
    line(0,0,0,0,origin_size,0);
    stroke(0,0,255);
    line(0,0,0,0,0,origin_size);
    
    // Graphic lines tha show the limits
    rotateZ( -radians(node_DH[i][3]) );
    rotateZ( radians(node_limit[i][0]) );
    stroke(0);
    line(0,0,0, origin_size+20,0,0);
    rotateZ( -radians(node_limit[i][0]) );
    rotateZ( radians(node_limit[i][1]) );
    line(0,0,0, origin_size+20,0,0);
    
    popMatrix();
    noFill();
    noStroke();
  }
}

//----------------------------------------------------------
void getRobotPosition()
{
  source = 1;
}

//----------------------------------------------------------
/*void getTicks()
{
   source = 0;
   send_serial('Z',0,num_nodes);
}*/

//----------------------Send limits to Arduino----------------------
void setLimits(int id, float pos_limit, float neg_limit)
{
  myPort.write('W');
  myPort.write(id);
  //println("ID is",id);
  int pLimit = (int)(pos_limit*32768)/360;  //need to add bit_size[i]
  send_int(pLimit);
  
  int nLimit = (int)(neg_limit*32768)/360;
  send_int(nLimit);
  println("pos limit",pLimit,"neg limit",nLimit);
  println();
}

//---------------------Cylinder-----------------------------
void drawCylinder(int sides, float r, float h)
{
    float angle = 360 / sides;
    float halfHeight = h / 2;
    // draw top shape
    stroke(0);
    beginShape();
    for (int i = 0; i < sides; i++) {
        float x = cos( radians( i * angle ) ) * r;
        float y = sin( radians( i * angle ) ) * r;
        vertex( x, y, -halfHeight );    
    }
    endShape(CLOSE);
    
    // draw bottom shape
    beginShape();
    for (int i = 0; i < sides; i++) {
        float x = cos( radians( i * angle ) ) * r;
        float y = sin( radians( i * angle ) ) * r;
        vertex( x, y, halfHeight );    
    }
    endShape(CLOSE);
    
    // draw body
    noStroke();
    beginShape(TRIANGLE_STRIP);
    for (int i = 0; i < sides + 1; i++) {
        float x = cos( radians( i * angle ) ) * r;
        float y = sin( radians( i * angle ) ) * r;
        vertex( x, y, halfHeight);
        vertex( x, y, -halfHeight);    
    }
    endShape(CLOSE); 
} 


//--------------------------------------------------------
void send_serial(char a, int id, int val)
{
  stop_ser_event = true;  // Stop Serial event handler from beeing called
  myPort.clear();    // Clear port of any data
  byte MSB,LSB,sing;
  sing = (byte) ((val & 0x7F000000) >> 24);

  if(sing==127)
  {
    MSB = (byte) ~((val & 0x0000FF00) >> 8);  //SB
    LSB = (byte) ~(val & 0x000000FF);  //LSB
    LSB++;
  }
  else
  {
    MSB = (byte) ((val & 0x0000FF00) >> 8);  //SB
    LSB = (byte) (val & 0x000000FF);  //LSB
  }
  id = starting_id + id;
  myPort.write((char)a);
  myPort.write(id);
  myPort.write(sing);
  myPort.write(MSB);
  myPort.write(LSB);
  delay(100);
  stop_ser_event = false;  // Allow serial event handler to be called again
}

//-------------------------------------------------------------------
void send_int(int val)
{
  stop_ser_event = true;  // Stop Serial event handler from beeing called
  //myPort.clear();    // Clear port of any data
  byte MSB,LSB,sing;
  sing = (byte) ((val & 0x7F000000) >> 24);

  if(sing==127)
  {
    MSB = (byte) ~((val & 0x0000FF00) >> 8);  //SB
    LSB = (byte) ~(val & 0x000000FF);  //LSB
    LSB++;
    sing = 1;
  }
  else
  {
    MSB = (byte) ((val & 0x0000FF00) >> 8);  //SB
    LSB = (byte) (val & 0x000000FF);  //LSB
    sing = 0;
  }
  myPort.write(sing);
  myPort.write(MSB);
  myPort.write(LSB);
  delay(100);
  stop_ser_event = false;  // Allow serial event handler to be called again
}